/*
 *                          The Art Of
 *                      D E M O M A K I N G
 *
 *
 *                     by Alex J. Champandard
 *                          Base Sixteen
 *
 *
 *                http://www.flipcode.com/demomaking
 *
 *                This file is in the public domain.
 *                      Use at your own risk.
 *
 *
 *                 Compile with DJGPP:  make music
 *
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>
#include <time.h>
#include <dos.h>
#include "midasdll.h"

long long tickCount = 0;

/*
 * it would be better to replace our timer with this procedure
 * but the way midas handles it makes our program windows 98 unfriendly
 */
void MIDAS_CALL TimerCallback()
{
     tickCount++;
}

/*
 * this is called when a sync mark Wxx is encountered in the module
 */
void MIDAS_CALL MusicCallback( unsigned syncInfo, unsigned position, unsigned row )
{
   cout << syncInfo << endl;
}

/*
 * the main procedure
 */
int main(void)
{
    MIDASmodule module;
    MIDASmodulePlayHandle playHandle;

 // startup midas, should check for errors (see midas' documentation to do that)
    MIDASstartup();
    MIDASinit();

 // load Steve's cool module
    module = MIDASloadModule( "lord.xm" );

 // get the play handle so we can reference it in the future
    playHandle = MIDASplayModule( module, true );

 // set our synchronisation call back
    MIDASsetMusicSyncCallback( playHandle, &MusicCallback );

 // implement a new TIMER procedure
    MIDASsetTimerCallbacks( 70000, FALSE, &TimerCallback, NULL, NULL );

 // and start playing... we can forget about it now
    MIDASstartBackgroundPlay( 0 );

 // run a minimal loop
    while (!kbhit())
    {

         while (inportb(0x3da) & 0x08);
         while (!(inportb(0x3da) & 0x08));

    }

// stop playing the module
    MIDASstopModule(playHandle);
    MIDASstopBackgroundPlay();
    MIDASfreeModule(module);

// shut down midas
    MIDASclose();

    return 0;
}
